<?php
namespace controleur;

use config\Validation;

class FrontControleur
{
    public function __construct()
    {
        global $twig;
        session_start();
        $dVueErreur = [];
        $actions = array(
            "Admin" => [
                "supprimerCompte", "consulterSignalement", "creerEvenement", "supprimerEvenement","supprimerOffre"
            ],
            "Modérateur" => [
                //TODO
            ],
            "Membre" => [
                "deconnexion","proposerOffre","consulterProfil","modifierProfil","signaler"
            ],
            "Utilisateur" => [
                "connection", "inscription", "accueil","consulterProfilLimite"
            ]
        );

        $action = Validation::nettoyerString($_GET["action"] ?? "");
        if(in_array($action,$actions['Admin'])) {
            if (false) { //TODO: tester si connecté en tant qu'admin via la session
                $dVueErreur[] = 'Veuillez vous connecter';
                echo $twig->render('erreur.html', ['dVueEreur' => $dVueErreur]);
            } else{
                new AdminControleur();
            }
        }
        else if(in_array($action,$actions['Modérateur'])) {
            if (false) { //TODO: tester si connecté en tant que modérateur via la session
                $dVueErreur[] = 'Veuillez vous connecter';
                echo $twig->render('erreur.html', ['dVueEreur' => $dVueErreur]);
            } else{
                new ModerateurControleur();
            }
        }
        else if(in_array($action,$actions['Membre'])) {
            if (isset($_SESSION["login"]) && !empty($_SESSION["login"]) == null) {
                $dVueErreur[] = 'Veuillez vous connecter';
                echo $twig->render('erreur.html', ['dVueEreur' => $dVueErreur]);
            } else{
                new MembreControleur();
            }
        }else{
            new UtilisateurControleur();
        }
    }
}
